/* $Id: cpl_imagelist_io.h,v 1.17 2006/08/23 13:44:31 yjung Exp $
 *
 * This file is part of the ESO Common Pipeline Library
 * Copyright (C) 2001-2004 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: yjung $
 * $Date: 2006/08/23 13:44:31 $
 * $Revision: 1.17 $
 * $Name: cpl-3_1 $
 */

#ifndef CPL_IMAGELIST_IO_H
#define CPL_IMAGELIST_IO_H

/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>

#include "cpl_image.h"
#include "cpl_imagelist.h"
#include "cpl_vector.h"

CPL_BEGIN_DECLS

/*-----------------------------------------------------------------------------
                            Function prototypes
 -----------------------------------------------------------------------------*/

/* Imagelist constructors */
cpl_imagelist * cpl_imagelist_new(void);
cpl_imagelist * cpl_imagelist_load(const char *, cpl_type, int) ;
cpl_imagelist * cpl_imagelist_load_window(const char *, cpl_type, int, int,
        int, int, int) ;

/* Imagelist accessors */
int cpl_imagelist_get_size(const cpl_imagelist *) ;
cpl_image * cpl_imagelist_get(const cpl_imagelist *, int) ;
cpl_error_code cpl_imagelist_set(cpl_imagelist *, cpl_image *, int) ;
cpl_image * cpl_imagelist_unset(cpl_imagelist *, int) ;

/* Imagelist destructor */
void cpl_imagelist_delete(cpl_imagelist *) ;

/* Others */
cpl_imagelist * cpl_imagelist_duplicate(const cpl_imagelist *) ;
cpl_error_code cpl_imagelist_erase(cpl_imagelist *, const cpl_vector *) ;
int cpl_imagelist_is_uniform(const cpl_imagelist *) ;

/* Saving function */
cpl_error_code cpl_imagelist_save(const cpl_imagelist *, const char *,
                                  cpl_type_bpp, const cpl_propertylist *,
                                  unsigned);
CPL_END_DECLS

#endif 
